/********************************************/
/* I[vjOf̃OtBbNύX */
/* iSv[̃OtBbNj             */
/********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,k,m,c;
	int		dt[32];
	int		dto,sft;


	if (argc != 3) {
		fprintf(stderr, "Usage: conv_p4 inputfile outputfile\n");
		exit(1);
	}

/* open files */


	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	j = 0;
	while ( (c = fgetc(infp)) != EOF) {
		dt[j] = c;
		if (j == 31) {

/* dt[ 0: 7]:Lrbg */
/* dt[ 8:15]: */
/* dt[16:23]: */
/* dt[24:31]: */

			for (k = 0;k < 8;k ++) {
				sft = 0x80;
				for (m = 0;m < 4;m ++) {
					dto = 0x10;
					if ( (dt[0*8+k] & sft) != 0) {
						dto |= 0x01;
					}
					if ( (dt[3*8+k] & sft) != 0) {
						dto |= 0x08;
					}
					if ( (dt[2*8+k] & sft) != 0) {
						dto |= 0x04;
					}
					if ( (dt[1*8+k] & sft) != 0) {
						dto |= 0x02;
					}
					fputc(dto,outfp);
					sft = sft >> 2;
				}
			}

			j = 0;
		} else {
			j ++;
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

