/**************************************/
/* Pv[̃OtBbNύX */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,k,m,c;
	int		dto,sft;
	int		startadd,endadd;


	if (argc != 5) {
		fprintf(stderr, "Usage: conv_p1 startadd endadd inputfile outputfile\n");
		exit(1);
	}

/* open files */

	sscanf(argv[1],"%x",&startadd);
	sscanf(argv[2],"%x",&endadd);


	if ((infp = fopen(argv[3], "rb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	for (i = 0;i < startadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		fputc(c,outfp);
	}

	for (;i < endadd;i ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}

		sft = 0x80;
		dto = 0x00;
		for (m = 0;m < 4;m ++) {
			if ( (c & sft) != 0) {
				dto |= 0x10;
			}
			dto = dto << 1;
			sft = sft >> 2;
		}
		fputc(dto,outfp);

	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

