/**************************************/
/* Rv[̃OtBbNύX */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	256
#define	MAXHEIGHT	640

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		i,j,k,c;
	int		x,y,height,width;
	int		a0,a1,a2,a3,a5,a6,a7;
	int		sft,m,p1,p2;
	int		m_b,p1_b,p2_b;
	int		dtout0,dtout1;
	int		dt[96];
	int		pixel[MAXWIDTH][MAXHEIGHT];
	int		wb;
	int		ivflag,ckflag;
	int		startadd,endadd;
	int		ii;


	if (argc != 6 && argc != 7) {
		fprintf(stderr, "Usage: conv_p3 startadd endadd width inputfile outputfile [-iv|ck]\n");
		exit(1);
	}

/* open files */

	sscanf(argv[1],"%x",&startadd);
	sscanf(argv[2],"%x",&endadd);

	wb = atoi(argv[3]);
	width = wb*8;

	if ((infp = fopen(argv[4], "rb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	if ((outfp = fopen(argv[5], "wb")) == NULL) {
		perror(argv[5]);
		exit(1);
	}

	ivflag = 0;
	ckflag = 0;
	if (argc == 7 && strncmp(argv[6],"-iv",4) == 0) {
		ivflag = 1;
	}
	if (argc == 7 && strncmp(argv[6],"-ck",4) == 0) {
		ckflag = 1;
	}

	for (ii = 0;ii < startadd;ii ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}
		fputc(c,outfp);
	}

	i = 0;
	y = 0;
	for (;ii < endadd;ii ++) {
		if ( (c = fgetc(infp)) == EOF) {
			break;
		}

		dt[i] = c;
		if (i == wb*3-1) {

			for (k = 0;k < wb;k ++) {
				sft = 0x80;
				for (m = 0;m < 8;m ++) {
					pixel[k*8+m][y] = 0x00;
					if ( (dt[1*wb+k] & sft) != 0) {		/* P1 */
						pixel[k*8+m][y] |= 0x40;
					}
					if ( (dt[2*wb+k] & sft) != 0) {		/* P2 */
						pixel[k*8+m][y] |= 0x20;
					}
					if ( (dt[0*wb+k] & sft) == 0) {		/* }XN */
						pixel[k*8+m][y] = 0x80;
					}
					sft = sft >> 1;
				}
			}

			y ++;
			i = 0;
		} else {
			i ++;
		}

	}

	height = y;


/* cȂ`FbJ[͗lɕύX */
	if (ckflag == 1) {
		for (y = 0;y < height;y ++) {
			a5 = 0xff;
			a6 = 0xfe;
			a7 = 0xfd;
			for (x = 0;x < width;x += 4) {
				a0 = pixel[x+0][y];
				a1 = pixel[x+1][y];
				a2 = pixel[x+2][y];
				a3 = pixel[x+3][y];

												/* 5 6 7 0 1 2 3 */
				if (a0 == a2 && a1 == a3) {		/*       A B A B */
					if ((y%2) == 0) {			/*        A   B  */
						pixel[x+0][y] = a0;
						pixel[x+2][y] = a1;
					} else {					/*        B   A  */
						pixel[x+0][y] = a1;
						pixel[x+2][y] = a0;
					}
				}

												/* 5 6 7 0 1 2 3 */
				if (a0 == a6 && a1 == a7) {		/*   A B A B     */
					if ((y%2) == 0) {			/*    B   A      */
						pixel[x+0][y] = a0;
						pixel[x-2][y] = a1;
					} else {					/*    A   B      */
						pixel[x+0][y] = a1;
						pixel[x-2][y] = a0;
					}
				}

												/* 5 6 7 0 1 2 3 */
				if (a0 == a2 && a1 == a7) {		/*     B A B A   */
					if ((y%2) == 0) {			/*        A   B  */
						pixel[x+0][y] = a0;
						pixel[x+2][y] = a1;
					} else {					/*        B   A  */
						pixel[x+0][y] = a1;
						pixel[x+2][y] = a0;
					}
				}

												/* 5 6 7 0 1 2 3 */
				if (a0 == a6 && a7 == a5) {		/* B A B A       */
					if ((y%2) == 0) {			/*    B   A      */
						pixel[x+0][y] = a0;
						pixel[x-2][y] = a7;
					} else {					/*    A   B      */
						pixel[x+0][y] = a7;
						pixel[x-2][y] = a0;
					}
				}

				a5 = a1;
				a6 = a2;
				a7 = a3;

			}
		}
	}


/* p^[f[^ */
	if (ivflag == 1) {
		for (y = 0;y < height;y ++) {
			for (x = 0;x < width;x += 2) {
				a0 = pixel[x+0][y];
				a1 = pixel[x+1][y];
				pixel[x+0][y] = a1;
			}
		}
	}


/* f[^o */
	for (y = 0;y < height;y ++) {
		for (k = 0;k < wb;k ++) {
			a0 = pixel[k*8+0][y];
			a1 = pixel[k*8+2][y];
			a2 = pixel[k*8+4][y];
			a3 = pixel[k*8+6][y];

			dtout0 = a0;
			if ( (a0 & 0x80) == 0) {
				a1 = a1 >> 3;
			} else {
				a1 = a1 >> 1;
			}
			dtout0 = dtout0 | a1;

			dtout1 = a2;
			if ( (a2 & 0x80) == 0) {
				a3 = a3 >> 3;
			} else {
				a3 = a3 >> 1;
			}
			dtout1 = dtout1 | a3;

			fputc(dtout0,outfp);
			fputc(dtout1,outfp);
			fputc(0x00,outfp);
		}
	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);

}

