/****************************************************/
/* make filelist                                    */
/*                                                  */
/* t@CZN^PʂŊi[邽߂̃Xg */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXFILE		96
#define	MAXNAME		16


int main(int argc, char **argv)
{
	FILE	*infp, *outbinfp, *outtxtfp, *flistfp;

	int		i,j;
	char	fname[MAXNAME];
	int		filelen;
	int		readflag;

	int		trackno, secno;

	if (argc != 4) {
		fprintf(stderr, "Usage: mkflist inputlist outbinlist outtxtlist\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "r")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outbinfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outtxtfp = fopen(argv[3], "w")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	trackno = 1;
	secno = 0;
	for (i = 0;i < MAXFILE;i ++) {
		if (fscanf(infp,"%s",fname) != EOF) {

			if ((flistfp = fopen(fname, "rb")) == NULL) {
				perror(fname);
				exit(1);
			}

			fseek(flistfp, 0, SEEK_END);
			filelen = ftell(flistfp);
			fclose(flistfp);

			for (j = 0;j < strlen(fname);j ++) {
				fputc(fname[j], outbinfp);
			}
			for (;j < 12;j ++) {
				fputc(0x00, outbinfp);
			}

			fputc(trackno, outbinfp);
			fputc(secno+1, outbinfp);

			fputc(filelen & 0x00ff, outbinfp);
			fputc( (filelen & 0xff00) >> 8, outbinfp);

			fprintf(outtxtfp,"%s 0 %d %d\n", fname, trackno, secno+1);


			secno   = secno + ( ( (filelen+0x00ff) & 0xff00) >> 8);
			trackno = trackno + ( (secno & 0xfff0) >> 4);
			secno   = (secno & 0x000f);

		} else {
			for (j = 0;j < 16;j ++) {
				fputc(0x00, outbinfp);
			}
		}

	}

	fclose(infp);
	fclose(outbinfp);
	fclose(outtxtfp);

}

